<center><a href="pops.c">Actual source code: pops.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:17:47+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSC_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/*</font>
<a name="line4">  4: </a><font color="#B22222">    Defines the operations for the Postscript <A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> implementation.</font>
<a name="line5">  5: </a><font color="#B22222">*/</font>

<a name="line7"> 7: </a> #include <A href="../../../../../src/sys/draw/impls/ps/psimpl.h.html">src/sys/draw/impls/ps/psimpl.h</A>

<a name="line11"> 11: </a><font color="#B22222">/*@C</font>
<a name="line12"> 12: </a><font color="#B22222">      <A href="../../../../../docs/manualpages/Draw/PetscDrawOpenPS.html#PetscDrawOpenPS">PetscDrawOpenPS</A> - Opens a <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> that generates Postscript</font>

<a name="line14"> 14: </a><font color="#B22222">  Collective on <A href="../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A></font>

<a name="line16"> 16: </a><font color="#B22222">  Input Parameters:</font>
<a name="line17"> 17: </a><font color="#B22222">+   <A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A> - communicator that shares the <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A></font>
<a name="line18"> 18: </a><font color="#B22222">-   file - name of file where Postscript is to be stored</font>

<a name="line20"> 20: </a><font color="#B22222">  Output Parameter:</font>
<a name="line21"> 21: </a><font color="#B22222">.  viewer - the <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> object</font>

<a name="line23"> 23: </a><font color="#B22222">  Level: beginner</font>

<a name="line25"> 25: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/Draw/PetscDrawDestroy.html#PetscDrawDestroy">PetscDrawDestroy</A>(), <A href="../../../../../docs/manualpages/Draw/PetscDrawOpenX.html#PetscDrawOpenX">PetscDrawOpenX</A>(), <A href="../../../../../docs/manualpages/Draw/PetscDrawCreate.html#PetscDrawCreate">PetscDrawCreate</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerDrawOpen.html#PetscViewerDrawOpen">PetscViewerDrawOpen</A>(), <A href="../../../../../docs/manualpages/Viewer/PetscViewerDrawGetDraw.html#PetscViewerDrawGetDraw">PetscViewerDrawGetDraw</A>()</font>
<a name="line26"> 26: </a><font color="#B22222">@*/</font>
<a name="line27"> 27: </a><strong><font color="#4169E1"><a name="PetscDrawOpenPS"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/Draw/PetscDrawOpenPS.html#PetscDrawOpenPS">PetscDrawOpenPS</A>(<A href="../../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A> <A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,char *filename,<A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> *draw)</font></strong>
<a name="line28"> 28: </a>{

<a name="line32"> 32: </a>  <A href="../../../../../docs/manualpages/Draw/PetscDrawCreate.html#PetscDrawCreate">PetscDrawCreate</A>(<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,filename,0,0,0,0,0,draw);
<a name="line33"> 33: </a>  <A href="../../../../../docs/manualpages/Draw/PetscDrawSetType.html#PetscDrawSetType">PetscDrawSetType</A>(*draw,PETSC_DRAW_PS);
<a name="line34"> 34: </a>  <font color="#4169E1">return</font>(0);
<a name="line35"> 35: </a>}

<a name="line37"> 37: </a><font color="#B22222">/*</font>
<a name="line38"> 38: </a><font color="#B22222">     These macros transform from the users coordinates to the Postscript</font>
<a name="line39"> 39: </a><font color="#B22222">*/</font>
<a name="line40"> 40: </a><strong><font color="#228B22">#define WIDTH  8.5*72</font></strong>
<a name="line41"> 41: </a><strong><font color="#228B22">#define HEIGHT 11*72</font></strong>
<a name="line42"> 42: </a><strong><font color="#228B22">#define XTRANS(win,x) \</font></strong>
<a name="line43"> 43: </a><strong><font color="#228B22">   ((WIDTH)*((win)-&gt;port_xl+(((x-(win)-&gt;coor_xl)*((win)-&gt;port_xr-(win)-&gt;port_xl))/((win)-&gt;coor_xr-(win)-&gt;coor_xl))))</font></strong>
<a name="line44"> 44: </a><strong><font color="#228B22">#define YTRANS(win,y) \</font></strong>
<a name="line45"> 45: </a><strong><font color="#228B22">   ((HEIGHT)*((win)-&gt;port_yl+(((y-(win)-&gt;coor_yl)*((win)-&gt;port_yr-(win)-&gt;port_yl))/((win)-&gt;coor_yr-(win)-&gt;coor_yl))))</font></strong>

<a name="line47"> 47: </a><font color="#B22222">/*</font>
<a name="line48"> 48: </a><font color="#B22222">    Contains the RGB colors for the PETSc defined colors</font>
<a name="line49"> 49: </a><font color="#B22222">*/</font>
<a name="line50"> 50: </a>static <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>  rgb[3][256];
<a name="line51"> 51: </a>static <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> rgbfilled = <A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;

<a name="line53"> 53: </a><strong><font color="#228B22">#define PSSetColor(ps,c)   (((c) == ps-&gt;currentcolor) ? 0 : \</font></strong>
<a name="line54"> 54: </a><strong><font color="#228B22">(ps-&gt;currentcolor = (c),<A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,</font><font color="#666666">"%G %G %G setrgbcolor\n"</font><font color="#228B22">,rgb[0][c],rgb[1][c],rgb[2][c])))</font></strong>

<a name="line58"> 58: </a><strong><font color="#4169E1"><a name="PetscDrawPoint_PS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscDrawPoint_PS(<A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> draw,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> x,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>  y,int c)</font></strong>
<a name="line59"> 59: </a>{
<a name="line60"> 60: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      xx,yy;
<a name="line62"> 62: </a>  PetscDraw_PS*  ps = (PetscDraw_PS*)draw-&gt;data;

<a name="line65"> 65: </a>  xx = XTRANS(draw,x);  yy = YTRANS(draw,y);
<a name="line66"> 66: </a>  PSSetColor(ps,c);
<a name="line67"> 67: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G moveto %G %G lineto stroke\n"</font>,xx,yy,xx+1,yy);
<a name="line68"> 68: </a>  <font color="#4169E1">return</font>(0);
<a name="line69"> 69: </a>}

<a name="line73"> 73: </a><strong><font color="#4169E1"><a name="PetscDrawLine_PS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscDrawLine_PS(<A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> draw,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> xl,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> yl,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> xr,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> yr,int c)</font></strong>
<a name="line74"> 74: </a>{
<a name="line75"> 75: </a>  PetscDraw_PS*  ps = (PetscDraw_PS*)draw-&gt;data;
<a name="line76"> 76: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      x1,y_1,x2,y2;

<a name="line80"> 80: </a>  x1 = XTRANS(draw,xl);   x2  = XTRANS(draw,xr);
<a name="line81"> 81: </a>  y_1 = YTRANS(draw,yl);   y2  = YTRANS(draw,yr);
<a name="line82"> 82: </a>  PSSetColor(ps,c);
<a name="line83"> 83: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G moveto %G %G lineto stroke\n"</font>,x1,y_1,x2,y2);
<a name="line84"> 84: </a>  <font color="#4169E1">return</font>(0);
<a name="line85"> 85: </a>}

<a name="line89"> 89: </a><strong><font color="#4169E1"><a name="PetscDrawStringSetSize_PS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscDrawStringSetSize_PS(<A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> draw,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> x,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>  y)</font></strong>
<a name="line90"> 90: </a>{
<a name="line91"> 91: </a>  PetscDraw_PS*  ps = (PetscDraw_PS*)draw-&gt;data;
<a name="line93"> 93: </a>  int            w,h;

<a name="line96"> 96: </a>  w = (int)((WIDTH)*x*(draw-&gt;port_xr - draw-&gt;port_xl)/(draw-&gt;coor_xr - draw-&gt;coor_xl));
<a name="line97"> 97: </a>  h = (int)((HEIGHT)*y*(draw-&gt;port_yr - draw-&gt;port_yl)/(draw-&gt;coor_yr - draw-&gt;coor_yl));
<a name="line98"> 98: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"/Helvetica-normal findfont %G scalefont setfont\n"</font>,(w+h)/2.0);
<a name="line99"> 99: </a>  <font color="#4169E1">return</font>(0);
<a name="line100">100: </a>}

<a name="line104">104: </a><strong><font color="#4169E1"><a name="PetscDrawStringGetSize_PS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscDrawStringGetSize_PS(<A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> draw,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> *x,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>  *y)</font></strong>
<a name="line105">105: </a>{
<a name="line106">106: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>   w = 9,h = 9;

<a name="line109">109: </a>  *x = w*(draw-&gt;coor_xr - draw-&gt;coor_xl)/(WIDTH)*(draw-&gt;port_xr - draw-&gt;port_xl);
<a name="line110">110: </a>  *y = h*(draw-&gt;coor_yr - draw-&gt;coor_yl)/(HEIGHT)*(draw-&gt;port_yr - draw-&gt;port_yl);
<a name="line111">111: </a>  <font color="#4169E1">return</font>(0);
<a name="line112">112: </a>}

<a name="line116">116: </a><strong><font color="#4169E1"><a name="PetscDrawString_PS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscDrawString_PS(<A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> draw,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> x,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>  y,int c,const char chrs[])</font></strong>
<a name="line117">117: </a>{
<a name="line118">118: </a>  PetscDraw_PS* ps = (PetscDraw_PS*)draw-&gt;data;
<a name="line119">119: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>     x1,y_1;

<a name="line123">123: </a>  PSSetColor(ps,c);
<a name="line124">124: </a>  x1 = XTRANS(draw,x);
<a name="line125">125: </a>  y_1 = YTRANS(draw,y);
<a name="line126">126: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G moveto (%s) show\n"</font>,x1,y_1,chrs);
<a name="line127">127: </a>  <font color="#4169E1">return</font>(0);
<a name="line128">128: </a>}

<a name="line132">132: </a><strong><font color="#4169E1"><a name="PetscDrawStringVertical_PS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscDrawStringVertical_PS(<A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> draw,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> x,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>  y,int c,const char chrs[])</font></strong>
<a name="line133">133: </a>{
<a name="line134">134: </a>  PetscDraw_PS*  ps = (PetscDraw_PS*)draw-&gt;data;
<a name="line135">135: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      x1,y_1;

<a name="line139">139: </a>  PSSetColor(ps,c);
<a name="line140">140: </a>  x1 = XTRANS(draw,x);
<a name="line141">141: </a>  y_1 = YTRANS(draw,y);
<a name="line142">142: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"gsave %G %G moveto 90 rotate (%s) show grestore\n"</font>,x1,y_1,chrs);
<a name="line143">143: </a>  <font color="#4169E1">return</font>(0);
<a name="line144">144: </a>}

<a name="line146">146: </a><strong><font color="#4169E1">static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscDrawInterpolatedTriangle_PS(PetscDraw_PS*,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,int,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,int,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,int)</font></strong>;

<a name="line150">150: </a><strong><font color="#4169E1"><a name="PetscDrawTriangle_PS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscDrawTriangle_PS(<A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> draw,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> X1,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> Y_1,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> X2,</font></strong>
<a name="line151">151: </a><strong><font color="#4169E1">                          <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> Y2,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> X3,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> Y3,int c1,int c2,int c3)</font></strong>
<a name="line152">152: </a>{
<a name="line153">153: </a>  PetscDraw_PS*  ps = (PetscDraw_PS*)draw-&gt;data;
<a name="line155">155: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      x1,y_1,x2,y2,x3,y3;

<a name="line158">158: </a>  x1   = XTRANS(draw,X1);
<a name="line159">159: </a>  y_1  = YTRANS(draw,Y_1);
<a name="line160">160: </a>  x2   = XTRANS(draw,X2);
<a name="line161">161: </a>  y2   = YTRANS(draw,Y2);
<a name="line162">162: </a>  x3   = XTRANS(draw,X3);
<a name="line163">163: </a>  y3   = YTRANS(draw,Y3);

<a name="line165">165: </a>  <font color="#4169E1">if</font> (c1 == c2 &amp;&amp; c2 == c3) {
<a name="line166">166: </a>    PSSetColor(ps,c1);
<a name="line167">167: </a>    <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G moveto %G %G lineto %G %G lineto fill\n"</font>,x1,y_1,x2,y2,x3,y3);
<a name="line168">168: </a>  } <font color="#4169E1">else</font> {
<a name="line169">169: </a>    PetscDrawInterpolatedTriangle_PS(ps,x1,y_1,c1,x2,y2,c2,x3,y3,c3);
<a name="line170">170: </a>  }
<a name="line171">171: </a>  <font color="#4169E1">return</font>(0);
<a name="line172">172: </a>}

<a name="line176">176: </a><strong><font color="#4169E1"><a name="PetscDrawRectangle_PS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscDrawRectangle_PS(<A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> draw,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> X1,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> Y_1,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> X2,</font></strong>
<a name="line177">177: </a><strong><font color="#4169E1">                          <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> Y2,int c1,int c2,int c3,int c4)</font></strong>
<a name="line178">178: </a>{
<a name="line179">179: </a>  PetscDraw_PS*  ps = (PetscDraw_PS*)draw-&gt;data;
<a name="line181">181: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      x1,y_1,x2,y2,x3,y3,x4,y4;

<a name="line184">184: </a>  x1   = XTRANS(draw,X1);
<a name="line185">185: </a>  y_1  = YTRANS(draw,Y_1);
<a name="line186">186: </a>  x2   = XTRANS(draw,X2);
<a name="line187">187: </a>  y2   = YTRANS(draw,Y_1);
<a name="line188">188: </a>  x3   = XTRANS(draw,X2);
<a name="line189">189: </a>  y3   = YTRANS(draw,Y2);
<a name="line190">190: </a>  x4   = XTRANS(draw,X1);
<a name="line191">191: </a>  y4   = YTRANS(draw,Y2);

<a name="line193">193: </a>  PSSetColor(ps,(c1+c2+c3+c4)/4);
<a name="line194">194: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G moveto %G %G lineto %G %G lineto %G %G lineto %G %G lineto fill\n"</font>,x1,y_1,x2,y2,x3,y3,x4,y4,x1,y_1);
<a name="line195">195: </a>  <font color="#4169E1">return</font>(0);
<a name="line196">196: </a>}

<a name="line200">200: </a><strong><font color="#4169E1"><a name="PetscDrawDestroy_PS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscDrawDestroy_PS(<A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> draw)</font></strong>
<a name="line201">201: </a>{
<a name="line202">202: </a>  PetscDraw_PS   *ps = (PetscDraw_PS*)draw-&gt;data;
<a name="line204">204: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     show;
<a name="line205">205: </a>  char           *filename,par[PETSC_MAX_PATH_LEN];
<a name="line206">206: </a>
<a name="line208">208: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"\nshowpage\n"</font>);
<a name="line209">209: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(draw-&gt;prefix,<font color="#666666">"-draw_ps_show"</font>,&amp;show);
<a name="line210">210: </a>  <font color="#4169E1">if</font> (show) {
<a name="line211">211: </a>    <A href="../../../../../docs/manualpages/Viewer/PetscViewerFileGetName.html#PetscViewerFileGetName">PetscViewerFileGetName</A>(ps-&gt;ps_file,&amp;filename);
<a name="line212">212: </a>    <A href="../../../../../docs/manualpages/Sys/PetscStrcpy.html#PetscStrcpy">PetscStrcpy</A>(par,<font color="#666666">"ghostview "</font>);
<a name="line213">213: </a>    <A href="../../../../../docs/manualpages/Sys/PetscStrcat.html#PetscStrcat">PetscStrcat</A>(par,filename);
<a name="line214">214: </a><font color="#A020F0">#if defined(PETSC_HAVE_POPEN)    </font>
<a name="line215">215: </a>    <A href="../../../../../docs/manualpages/Sys/PetscPOpen.html#PetscPOpen">PetscPOpen</A>(draw-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,par,<font color="#666666">"r"</font>,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line216">216: </a><font color="#A020F0">#else</font>
<a name="line217">217: </a>    <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_SUP_SYS,<font color="#666666">"Cannot run external programs on this machine"</font>);
<a name="line218">218: </a><font color="#A020F0">#endif</font>
<a name="line219">219: </a>  }
<a name="line220">220: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(ps-&gt;ps_file);
<a name="line221">221: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(ps);
<a name="line222">222: </a>  <font color="#4169E1">return</font>(0);
<a name="line223">223: </a>}

<a name="line227">227: </a><strong><font color="#4169E1"><a name="PetscDrawSynchronizedFlush_PS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscDrawSynchronizedFlush_PS(<A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> draw)</font></strong>
<a name="line228">228: </a>{
<a name="line230">230: </a>  PetscDraw_PS*  ps = (PetscDraw_PS*)draw-&gt;data;

<a name="line233">233: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerFlush.html#PetscViewerFlush">PetscViewerFlush</A>(ps-&gt;ps_file);
<a name="line234">234: </a>  <font color="#4169E1">return</font>(0);
<a name="line235">235: </a>}

<a name="line239">239: </a><strong><font color="#4169E1"><a name="PetscDrawSynchronizedClear_PS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscDrawSynchronizedClear_PS(<A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> draw)</font></strong>
<a name="line240">240: </a>{
<a name="line242">242: </a>  PetscDraw_PS*  ps = (PetscDraw_PS*)draw-&gt;data;

<a name="line245">245: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerFlush.html#PetscViewerFlush">PetscViewerFlush</A>(ps-&gt;ps_file);
<a name="line246">246: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"\nshowpage\n"</font>);
<a name="line247">247: </a>  <font color="#4169E1">return</font>(0);
<a name="line248">248: </a>}

<a name="line250">250: </a>static <font color="#4169E1">struct _PetscDrawOps</font> DvOps = { 0,
<a name="line251">251: </a>                                 0,
<a name="line252">252: </a>                                 PetscDrawLine_PS,
<a name="line253">253: </a>                                 0,
<a name="line254">254: </a>                                 0,
<a name="line255">255: </a>                                 PetscDrawPoint_PS,
<a name="line256">256: </a>                                 0,
<a name="line257">257: </a>                                 PetscDrawString_PS,
<a name="line258">258: </a>                                 PetscDrawStringVertical_PS,
<a name="line259">259: </a>                                 PetscDrawStringSetSize_PS,
<a name="line260">260: </a>                                 PetscDrawStringGetSize_PS,
<a name="line261">261: </a>                                 0,
<a name="line262">262: </a>                                 0,
<a name="line263">263: </a>                                 PetscDrawSynchronizedFlush_PS,
<a name="line264">264: </a>                                 PetscDrawRectangle_PS,
<a name="line265">265: </a>                                 PetscDrawTriangle_PS,
<a name="line266">266: </a>                                 0,
<a name="line267">267: </a>                                 0,
<a name="line268">268: </a>                                 0,
<a name="line269">269: </a>                                 PetscDrawSynchronizedClear_PS,
<a name="line270">270: </a>                                 0,
<a name="line271">271: </a>                                 0,
<a name="line272">272: </a>                                 0,
<a name="line273">273: </a>                                 0,
<a name="line274">274: </a>                                 0,
<a name="line275">275: </a>                                 0,
<a name="line276">276: </a>                                 PetscDrawDestroy_PS,
<a name="line277">277: </a>                                 0,
<a name="line278">278: </a>                                 0,
<a name="line279">279: </a>                                 0 };

<a name="line284">284: </a><strong><font color="#4169E1"><a name="PetscDrawCreate_PS"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PetscDrawCreate_PS(<A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> draw)</font></strong>
<a name="line285">285: </a>{
<a name="line286">286: </a>  PetscDraw_PS  *ps;
<a name="line288">288: </a>  int           ncolors,i;
<a name="line289">289: </a>  unsigned char *red,*green,*blue;
<a name="line290">290: </a>  static int    filecount = 0;
<a name="line291">291: </a>  char          buff[32];
<a name="line292">292: </a>  char          version[256];

<a name="line295">295: </a>  <font color="#4169E1">if</font> (!draw-&gt;display) {
<a name="line296">296: </a>    sprintf(buff,<font color="#666666">"defaultps%d.ps"</font>,filecount++);
<a name="line297">297: </a>    <A href="../../../../../docs/manualpages/Sys/PetscStrallocpy.html#PetscStrallocpy">PetscStrallocpy</A>(buff,&amp;draw-&gt;display);
<a name="line298">298: </a>  }

<a name="line300">300: </a>  <A href="../../../../../docs/manualpages/Sys/PetscGetVersion.html#PetscGetVersion">PetscGetVersion</A>(&amp;version,256);
<a name="line301">301: </a>  <A href="../../../../../docs/manualpages/Sys/PetscNew.html#PetscNew">PetscNew</A>(PetscDraw_PS,&amp;ps);
<a name="line302">302: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMemcpy.html#PetscMemcpy">PetscMemcpy</A>(draw-&gt;ops,&amp;DvOps,<font color="#4169E1">sizeof</font>(DvOps));
<a name="line303">303: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIOpen.html#PetscViewerASCIIOpen">PetscViewerASCIIOpen</A>(draw-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,draw-&gt;display,&amp;ps-&gt;ps_file);
<a name="line304">304: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%%!PS-Adobe-2.0\n"</font>);
<a name="line305">305: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%%%%Creator: PETSc %s\n"</font>,version);
<a name="line306">306: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%%%%Title: %s\n"</font>,draw-&gt;display);
<a name="line307">307: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%%%%Pages: 1\n"</font>);
<a name="line308">308: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%%%%PageOrder: Ascend\n"</font>);
<a name="line309">309: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%%%%BoundingBox: 0 0 612 792\n"</font>);
<a name="line310">310: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%%%%DocumentFonts: Helvetica-normal Symbol\n"</font>);
<a name="line311">311: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%%%%EndComments\n"</font>);
<a name="line312">312: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"/Helvetica-normal findfont 10 scalefont setfont\n"</font>);
<a name="line313">313: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"/c {setrgbcolor} def\n"</font>);
<a name="line314">314: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"/l {lineto stroke} def\n"</font>);
<a name="line315">315: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(ps-&gt;ps_file,<font color="#666666">"/m {moveto} def\n"</font>);

<a name="line317">317: </a>  ps-&gt;currentcolor = PETSC_DRAW_BLACK;

<a name="line319">319: </a>  <font color="#4169E1">if</font> (!rgbfilled) {
<a name="line320">320: </a>    rgbfilled = <A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line321">321: </a>    rgb[0][PETSC_DRAW_WHITE]       = 255/255;
<a name="line322">322: </a>    rgb[1][PETSC_DRAW_WHITE]       = 255/255;
<a name="line323">323: </a>    rgb[2][PETSC_DRAW_WHITE]       = 255/255;
<a name="line324">324: </a>    rgb[0][PETSC_DRAW_BLACK]       = 0;
<a name="line325">325: </a>    rgb[1][PETSC_DRAW_BLACK]       = 0;
<a name="line326">326: </a>    rgb[2][PETSC_DRAW_BLACK]       = 0;
<a name="line327">327: </a>    rgb[0][PETSC_DRAW_RED]         = 255/255;
<a name="line328">328: </a>    rgb[1][PETSC_DRAW_RED]         = 0;
<a name="line329">329: </a>    rgb[2][PETSC_DRAW_RED]         = 0;
<a name="line330">330: </a>    rgb[0][PETSC_DRAW_GREEN]       = 0;
<a name="line331">331: </a>    rgb[1][PETSC_DRAW_GREEN]       = 255./255;
<a name="line332">332: </a>    rgb[2][PETSC_DRAW_GREEN]       = 0;
<a name="line333">333: </a>    rgb[0][PETSC_DRAW_CYAN]        = 0;
<a name="line334">334: </a>    rgb[1][PETSC_DRAW_CYAN]        = 255./255;
<a name="line335">335: </a>    rgb[2][PETSC_DRAW_CYAN]        = 255./255;
<a name="line336">336: </a>    rgb[0][PETSC_DRAW_BLUE]        = 0;
<a name="line337">337: </a>    rgb[1][PETSC_DRAW_BLUE]        = 0;
<a name="line338">338: </a>    rgb[2][PETSC_DRAW_BLUE]        = 255./255;
<a name="line339">339: </a>    rgb[0][PETSC_DRAW_MAGENTA]     = 255./255;
<a name="line340">340: </a>    rgb[1][PETSC_DRAW_MAGENTA]     = 0;
<a name="line341">341: </a>    rgb[2][PETSC_DRAW_MAGENTA]     = 255./255;
<a name="line342">342: </a>    rgb[0][PETSC_DRAW_AQUAMARINE]  = 127./255;
<a name="line343">343: </a>    rgb[1][PETSC_DRAW_AQUAMARINE]  = 255./255;
<a name="line344">344: </a>    rgb[2][PETSC_DRAW_AQUAMARINE]  = 212./255;
<a name="line345">345: </a>    rgb[0][PETSC_DRAW_FORESTGREEN] = 34./255   ;
<a name="line346">346: </a>    rgb[1][PETSC_DRAW_FORESTGREEN] = 139./255.;
<a name="line347">347: </a>    rgb[2][PETSC_DRAW_FORESTGREEN] = 34./255. ;
<a name="line348">348: </a>    rgb[0][PETSC_DRAW_ORANGE]      = 255./255.    ;
<a name="line349">349: </a>    rgb[1][PETSC_DRAW_ORANGE]      = 165./255.;
<a name="line350">350: </a>    rgb[2][PETSC_DRAW_ORANGE]      = 0 ;
<a name="line351">351: </a>    rgb[0][PETSC_DRAW_VIOLET]      = 238./255.  ;
<a name="line352">352: </a>    rgb[1][PETSC_DRAW_VIOLET]      = 130./255.;
<a name="line353">353: </a>    rgb[2][PETSC_DRAW_VIOLET]      = 238./255.;
<a name="line354">354: </a>    rgb[0][PETSC_DRAW_BROWN]       = 165./255.   ;
<a name="line355">355: </a>    rgb[1][PETSC_DRAW_BROWN]       =  42./255.;
<a name="line356">356: </a>    rgb[2][PETSC_DRAW_BROWN]       = 42./255.;
<a name="line357">357: </a>    rgb[0][PETSC_DRAW_PINK]        = 255./255. ;
<a name="line358">358: </a>    rgb[1][PETSC_DRAW_PINK]        = 192./255. ;
<a name="line359">359: </a>    rgb[2][PETSC_DRAW_PINK]        = 203./255.;
<a name="line360">360: </a>    rgb[0][PETSC_DRAW_CORAL]       = 255./255.;
<a name="line361">361: </a>    rgb[1][PETSC_DRAW_CORAL]       = 127./255.;
<a name="line362">362: </a>    rgb[2][PETSC_DRAW_CORAL]       = 80./255.;
<a name="line363">363: </a>    rgb[0][PETSC_DRAW_GRAY]        = 190./255.  ;
<a name="line364">364: </a>    rgb[1][PETSC_DRAW_GRAY]        = 190./255.;
<a name="line365">365: </a>    rgb[2][PETSC_DRAW_GRAY]        = 190./255.;
<a name="line366">366: </a>    rgb[0][PETSC_DRAW_YELLOW]      = 255./255.    ;
<a name="line367">367: </a>    rgb[1][PETSC_DRAW_YELLOW]      = 255./255.;
<a name="line368">368: </a>    rgb[2][PETSC_DRAW_YELLOW]      = 0/255.;
<a name="line369">369: </a>    rgb[0][PETSC_DRAW_GOLD]        = 255./255.  ;
<a name="line370">370: </a>    rgb[1][PETSC_DRAW_GOLD]        =  215./255.;
<a name="line371">371: </a>    rgb[2][PETSC_DRAW_GOLD]        =  0;
<a name="line372">372: </a>    rgb[0][PETSC_DRAW_LIGHTPINK]   = 255./255.  ;
<a name="line373">373: </a>    rgb[1][PETSC_DRAW_LIGHTPINK]   = 182./255.;
<a name="line374">374: </a>    rgb[2][PETSC_DRAW_LIGHTPINK]   = 193./255.;
<a name="line375">375: </a>    rgb[0][PETSC_DRAW_MEDIUMTURQUOISE] = 72./255.;
<a name="line376">376: </a>    rgb[1][PETSC_DRAW_MEDIUMTURQUOISE] =  209./255.;
<a name="line377">377: </a>    rgb[2][PETSC_DRAW_MEDIUMTURQUOISE] =  204./255.;
<a name="line378">378: </a>    rgb[0][PETSC_DRAW_KHAKI]           = 240./255.  ;
<a name="line379">379: </a>    rgb[1][PETSC_DRAW_KHAKI]           = 230./255.;
<a name="line380">380: </a>    rgb[2][PETSC_DRAW_KHAKI]           = 140./255.;
<a name="line381">381: </a>    rgb[0][PETSC_DRAW_DIMGRAY]         = 105./255.  ;
<a name="line382">382: </a>    rgb[1][PETSC_DRAW_DIMGRAY]         = 105./255.;
<a name="line383">383: </a>    rgb[2][PETSC_DRAW_DIMGRAY]         = 105./255.;
<a name="line384">384: </a>    rgb[0][PETSC_DRAW_YELLOWGREEN]     = 154./255.   ;
<a name="line385">385: </a>    rgb[1][PETSC_DRAW_YELLOWGREEN]     = 205./255.;
<a name="line386">386: </a>    rgb[2][PETSC_DRAW_YELLOWGREEN]     =  50./255.;
<a name="line387">387: </a>    rgb[0][PETSC_DRAW_SKYBLUE]         = 135./255.  ;
<a name="line388">388: </a>    rgb[1][PETSC_DRAW_SKYBLUE]         = 206./255.;
<a name="line389">389: </a>    rgb[2][PETSC_DRAW_SKYBLUE]         = 235./255.;
<a name="line390">390: </a>    rgb[0][PETSC_DRAW_DARKGREEN]       = 0    ;
<a name="line391">391: </a>    rgb[1][PETSC_DRAW_DARKGREEN]       = 100./255.;
<a name="line392">392: </a>    rgb[2][PETSC_DRAW_DARKGREEN]       = 0;
<a name="line393">393: </a>    rgb[0][PETSC_DRAW_NAVYBLUE]        = 0   ;
<a name="line394">394: </a>    rgb[1][PETSC_DRAW_NAVYBLUE]        =  0;
<a name="line395">395: </a>    rgb[2][PETSC_DRAW_NAVYBLUE]        = 128./255.;
<a name="line396">396: </a>    rgb[0][PETSC_DRAW_SANDYBROWN]      = 244./255.   ;
<a name="line397">397: </a>    rgb[1][PETSC_DRAW_SANDYBROWN]      = 164./255.;
<a name="line398">398: </a>    rgb[2][PETSC_DRAW_SANDYBROWN]      = 96./255.;
<a name="line399">399: </a>    rgb[0][PETSC_DRAW_CADETBLUE]       =  95./255.  ;
<a name="line400">400: </a>    rgb[1][PETSC_DRAW_CADETBLUE]       = 158./255.;
<a name="line401">401: </a>    rgb[2][PETSC_DRAW_CADETBLUE]       = 160./255.;
<a name="line402">402: </a>    rgb[0][PETSC_DRAW_POWDERBLUE]      = 176./255.  ;
<a name="line403">403: </a>    rgb[1][PETSC_DRAW_POWDERBLUE]      = 224./255.;
<a name="line404">404: </a>    rgb[2][PETSC_DRAW_POWDERBLUE]      = 230./255.;
<a name="line405">405: </a>    rgb[0][PETSC_DRAW_DEEPPINK]        = 255./255. ;
<a name="line406">406: </a>    rgb[1][PETSC_DRAW_DEEPPINK]        =  20./255.;
<a name="line407">407: </a>    rgb[2][PETSC_DRAW_DEEPPINK]        = 147./255.;
<a name="line408">408: </a>    rgb[0][PETSC_DRAW_THISTLE]         = 216./255.  ;
<a name="line409">409: </a>    rgb[1][PETSC_DRAW_THISTLE]         = 191./255.;
<a name="line410">410: </a>    rgb[2][PETSC_DRAW_THISTLE]         = 216./255.;
<a name="line411">411: </a>    rgb[0][PETSC_DRAW_LIMEGREEN]       = 50./255.  ;
<a name="line412">412: </a>    rgb[1][PETSC_DRAW_LIMEGREEN]       = 205./255.;
<a name="line413">413: </a>    rgb[2][PETSC_DRAW_LIMEGREEN]       =  50./255.;
<a name="line414">414: </a>    rgb[0][PETSC_DRAW_LAVENDERBLUSH]   = 255./255.  ;
<a name="line415">415: </a>    rgb[1][PETSC_DRAW_LAVENDERBLUSH]   = 240./255.;
<a name="line416">416: </a>    rgb[2][PETSC_DRAW_LAVENDERBLUSH]   = 245./255.;

<a name="line418">418: </a>    <font color="#B22222">/* now do the uniform hue part of the colors */</font>
<a name="line419">419: </a>    ncolors = 256-PETSC_DRAW_BASIC_COLORS;
<a name="line420">420: </a>    <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(3*ncolors*<font color="#4169E1">sizeof</font>(unsigned char),&amp;red);
<a name="line421">421: </a>    green   = red   + ncolors;
<a name="line422">422: </a>    blue    = green + ncolors;
<a name="line423">423: </a>    PetscDrawUtilitySetCmapHue(red,green,blue,ncolors);
<a name="line424">424: </a>    <font color="#4169E1">for</font> (i=PETSC_DRAW_BASIC_COLORS; i&lt;ncolors+PETSC_DRAW_BASIC_COLORS; i++) {
<a name="line425">425: </a>      rgb[0][i]  = ((double)red[i-PETSC_DRAW_BASIC_COLORS])/255.;
<a name="line426">426: </a>      rgb[1][i]  = ((double)green[i-PETSC_DRAW_BASIC_COLORS])/255.;
<a name="line427">427: </a>      rgb[2][i]  = ((double)blue[i-PETSC_DRAW_BASIC_COLORS])/255.;
<a name="line428">428: </a>    }
<a name="line429">429: </a>    <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(red);
<a name="line430">430: </a>  }

<a name="line432">432: </a>  draw-&gt;data    = (void*)ps;
<a name="line433">433: </a>  <font color="#4169E1">return</font>(0);
<a name="line434">434: </a>}



<a name="line439">439: </a><font color="#B22222">/*</font>
<a name="line440">440: </a><font color="#B22222">         This works in Postscript coordinates</font>
<a name="line441">441: </a><font color="#B22222">*/</font>
<a name="line442">442: </a><font color="#B22222">/*  </font>

<a name="line444">444: </a><font color="#B22222">   this kind of thing should do contour triangles with Postscript level 3</font>
<a name="line445">445: </a><font color="#B22222">1000 dict begin</font>
<a name="line446">446: </a><font color="#B22222">  /ShadingType 4 def</font>
<a name="line447">447: </a><font color="#B22222">  /ColorSpace /DeviceRGB def</font>
<a name="line448">448: </a><font color="#B22222">  /DataSource [0 10 10 255 255 255 0 400 10 0 0 0 0 200 400 255 0 0] def</font>
<a name="line449">449: </a><font color="#B22222">  shfill</font>

<a name="line451">451: </a><font color="#B22222">   once we have Postscript level 3 we should put this in as an option</font>
<a name="line452">452: </a><font color="#B22222">*/</font>


<a name="line457">457: </a><strong><font color="#4169E1"><a name="PetscDrawInterpolatedTriangle_PS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscDrawInterpolatedTriangle_PS(PetscDraw_PS* ps,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> x1,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> y_1,int t1,</font></strong>
<a name="line458">458: </a><strong><font color="#4169E1">                                <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> x2,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> y2,int t2,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> x3,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> y3,int t3)</font></strong>
<a name="line459">459: </a>{
<a name="line460">460: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      rfrac,lfrac;
<a name="line461">461: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      lc,rc = 0.0,lx,rx = 0.0,xx,y;
<a name="line462">462: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      rc_lc,rx_lx,t2_t1,x2_x1,t3_t1,x3_x1,t3_t2,x3_x2;
<a name="line463">463: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      R_y2_y_1,R_y3_y_1,R_y3_y2;
<a name="line465">465: </a>  int            c;

<a name="line468">468: </a>  <font color="#B22222">/*</font>
<a name="line469">469: </a><font color="#B22222">        Is triangle even visible in window?</font>
<a name="line470">470: </a><font color="#B22222">  */</font>
<a name="line471">471: </a>  <font color="#4169E1">if</font> (x1 &lt; 0 &amp;&amp; x2 &lt; 0 &amp;&amp; x3 &lt; 0) <font color="#4169E1">return</font>(0);
<a name="line472">472: </a>  <font color="#4169E1">if</font> (y_1 &lt; 0 &amp;&amp; y2 &lt; 0 &amp;&amp; y3 &lt; 0) <font color="#4169E1">return</font>(0);
<a name="line473">473: </a>  <font color="#4169E1">if</font> (x1 &gt; 72*8.5 &amp;&amp; x2 &gt; 72*8.5 &amp;&amp; x3 &gt; 72*8.5) <font color="#4169E1">return</font>(0);
<a name="line474">474: </a>  <font color="#4169E1">if</font> (y_1 &gt; 72*11 &amp;&amp; y2 &gt; 72*11 &amp;&amp; y3 &gt; 72*11) <font color="#4169E1">return</font>(0);

<a name="line476">476: </a>  <font color="#B22222">/* scale everything by two to reduce the huge file; note this reduces the quality */</font>
<a name="line477">477: </a>  x1  /= 2.0;
<a name="line478">478: </a>  x2  /= 2.0;
<a name="line479">479: </a>  x3  /= 2.0;
<a name="line480">480: </a>  y_1 /= 2.0;
<a name="line481">481: </a>  y2  /= 2.0;
<a name="line482">482: </a>  y3  /= 2.0;
<a name="line483">483: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"gsave 2 2 scale\n"</font>);


<a name="line486">486: </a>  <font color="#B22222">/* Sort the vertices */</font>
<a name="line487">487: </a><strong><font color="#228B22">#define SWAP(a,b) {<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> _a; _a=a; a=b; b=_a;}</font></strong>
<a name="line488">488: </a><strong><font color="#228B22">#define ISWAP(a,b) {int _a; _a=a; a=b; b=_a;}</font></strong>
<a name="line489">489: </a>  <font color="#4169E1">if</font> (y_1 &gt; y2) {
<a name="line490">490: </a>    SWAP(y_1,y2);ISWAP(t1,t2); SWAP(x1,x2);
<a name="line491">491: </a>  }
<a name="line492">492: </a>  <font color="#4169E1">if</font> (y_1 &gt; y3) {
<a name="line493">493: </a>    SWAP(y_1,y3);ISWAP(t1,t3); SWAP(x1,x3);
<a name="line494">494: </a>  }
<a name="line495">495: </a>  <font color="#4169E1">if</font> (y2 &gt; y3) {
<a name="line496">496: </a>    SWAP(y2,y3);ISWAP(t2,t3); SWAP(x2,x3);
<a name="line497">497: </a>  }
<a name="line498">498: </a>  <font color="#B22222">/* This code is decidely non-optimal; it is intended to be a start at</font>
<a name="line499">499: </a><font color="#B22222">   an implementation */</font>

<a name="line501">501: </a>  <font color="#4169E1">if</font> (y2 != y_1) R_y2_y_1 = 1.0/((y2-y_1)); <font color="#4169E1">else</font> R_y2_y_1 = 0.0;
<a name="line502">502: </a>  <font color="#4169E1">if</font> (y3 != y_1) R_y3_y_1 = 1.0/((y3-y_1)); <font color="#4169E1">else</font> R_y3_y_1 = 0.0;
<a name="line503">503: </a>  t2_t1   = t2 - t1;
<a name="line504">504: </a>  x2_x1   = x2 - x1;
<a name="line505">505: </a>  t3_t1   = t3 - t1;
<a name="line506">506: </a>  x3_x1   = x3 - x1;
<a name="line507">507: </a>  <font color="#4169E1">for</font> (y=y_1; y&lt;=y2; y++) {
<a name="line508">508: </a>    <font color="#B22222">/* <A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> a line with the correct color from t1-t2 to t1-t3 */</font>
<a name="line509">509: </a>    <font color="#B22222">/* Left color is (y-y_1)/(y2-y_1) * (t2-t1) + t1 */</font>
<a name="line510">510: </a>    lfrac = ((y-y_1)) * R_y2_y_1;
<a name="line511">511: </a>    lc    = (lfrac * (t2_t1) + t1);
<a name="line512">512: </a>    lx    = (lfrac * (x2_x1) + x1);
<a name="line513">513: </a>    <font color="#B22222">/* Right color is (y-y_1)/(y3-y_1) * (t3-t1) + t1 */</font>
<a name="line514">514: </a>    rfrac = ((y - y_1)) * R_y3_y_1;
<a name="line515">515: </a>    rc    = (rfrac * (t3_t1) + t1);
<a name="line516">516: </a>    rx    = (rfrac * (x3_x1) + x1);
<a name="line517">517: </a>    <font color="#B22222">/* <A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> the line */</font>
<a name="line518">518: </a>    rc_lc = rc - lc;
<a name="line519">519: </a>    rx_lx = rx - lx;
<a name="line520">520: </a>    <font color="#4169E1">if</font> (rx &gt; lx) {
<a name="line521">521: </a>      <font color="#4169E1">for</font> (xx=lx; xx&lt;=rx; xx++) {
<a name="line522">522: </a>        c = (int)(((xx-lx) * (rc_lc)) / (rx_lx) + lc);
<a name="line523">523: </a>        <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G %G c\n"</font>,rgb[0][c],rgb[1][c],rgb[2][c]);
<a name="line524">524: </a>        <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G m %G %G l\n"</font>,xx,y,xx+1,y);
<a name="line525">525: </a>      }
<a name="line526">526: </a>    } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (rx &lt; lx) {
<a name="line527">527: </a>      <font color="#4169E1">for</font> (xx=lx; xx&gt;=rx; xx--) {
<a name="line528">528: </a>        c = (int)(((xx-lx) * (rc_lc)) / (rx_lx) + lc);
<a name="line529">529: </a>        <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G %G c\n"</font>,rgb[0][c],rgb[1][c],rgb[2][c]);
<a name="line530">530: </a>        <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G m %G %G l\n"</font>,xx,y,xx+1,y);
<a name="line531">531: </a>      }
<a name="line532">532: </a>    } <font color="#4169E1">else</font> {
<a name="line533">533: </a>      c = (int)lc;
<a name="line534">534: </a>      <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G %G c\n"</font>,rgb[0][c],rgb[1][c],rgb[2][c]);
<a name="line535">535: </a>      <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G m %G %G l\n"</font>,lx,y,lx+1,y);
<a name="line536">536: </a>    }
<a name="line537">537: </a>  }

<a name="line539">539: </a>  <font color="#B22222">/* For simplicity,"move" t1 to the intersection of t1-t3 with the line y=y2.</font>
<a name="line540">540: </a><font color="#B22222">     We take advantage of the previous iteration. */</font>
<a name="line541">541: </a>  <font color="#4169E1">if</font> (y2 &gt;= y3) {
<a name="line542">542: </a>    <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"grestore\n"</font>);
<a name="line543">543: </a>    <font color="#4169E1">return</font>(0);
<a name="line544">544: </a>  }
<a name="line545">545: </a>  <font color="#4169E1">if</font> (y_1 &lt; y2) {
<a name="line546">546: </a>    t1  = (int)rc;
<a name="line547">547: </a>    y_1 = y2;
<a name="line548">548: </a>    x1  = rx;

<a name="line550">550: </a>    t3_t1   = t3 - t1;
<a name="line551">551: </a>    x3_x1   = x3 - x1;
<a name="line552">552: </a>  }
<a name="line553">553: </a>  t3_t2 = t3 - t2;
<a name="line554">554: </a>  x3_x2 = x3 - x2;
<a name="line555">555: </a>  <font color="#4169E1">if</font> (y3 != y2) R_y3_y2 = 1.0/((y3-y2)); <font color="#4169E1">else</font> R_y3_y2 = 0.0;
<a name="line556">556: </a>  <font color="#4169E1">if</font> (y3 != y_1) R_y3_y_1 = 1.0/((y3-y_1)); <font color="#4169E1">else</font> R_y3_y_1 = 0.0;
<a name="line557">557: </a>  <font color="#4169E1">for</font> (y=y2; y&lt;=y3; y++) {
<a name="line558">558: </a>    <font color="#B22222">/* <A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> a line with the correct color from t2-t3 to t1-t3 */</font>
<a name="line559">559: </a>    <font color="#B22222">/* Left color is (y-y_1)/(y2-y_1) * (t2-t1) + t1 */</font>
<a name="line560">560: </a>    lfrac = ((y-y2)) * R_y3_y2;
<a name="line561">561: </a>    lc    = (lfrac * (t3_t2) + t2);
<a name="line562">562: </a>    lx    = (lfrac * (x3_x2) + x2);
<a name="line563">563: </a>    <font color="#B22222">/* Right color is (y-y_1)/(y3-y_1) * (t3-t1) + t1 */</font>
<a name="line564">564: </a>    rfrac = ((y - y_1)) * R_y3_y_1;
<a name="line565">565: </a>    rc    = (rfrac * (t3_t1) + t1);
<a name="line566">566: </a>    rx    = (rfrac * (x3_x1) + x1);
<a name="line567">567: </a>    <font color="#B22222">/* <A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A> the line */</font>
<a name="line568">568: </a>    rc_lc = rc - lc;
<a name="line569">569: </a>    rx_lx = rx - lx;
<a name="line570">570: </a>    <font color="#4169E1">if</font> (rx &gt; lx) {
<a name="line571">571: </a>      <font color="#4169E1">for</font> (xx=lx; xx&lt;=rx; xx++) {
<a name="line572">572: </a>        c = (int)(((xx-lx) * (rc_lc)) / (rx_lx) + lc);
<a name="line573">573: </a>        <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G %G c\n"</font>,rgb[0][c],rgb[1][c],rgb[2][c]);
<a name="line574">574: </a>        <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G m %G %G l\n"</font>,xx,y,xx+1,y);
<a name="line575">575: </a>      }
<a name="line576">576: </a>    } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (rx &lt; lx) {
<a name="line577">577: </a>      <font color="#4169E1">for</font> (xx=lx; xx&gt;=rx; xx--) {
<a name="line578">578: </a>        c = (int)(((xx-lx) * (rc_lc)) / (rx_lx) + lc);
<a name="line579">579: </a>        <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G %G c\n"</font>,rgb[0][c],rgb[1][c],rgb[2][c]);
<a name="line580">580: </a>        <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G m %G %G l\n"</font>,xx,y,xx+1,y);
<a name="line581">581: </a>      }
<a name="line582">582: </a>    } <font color="#4169E1">else</font> {
<a name="line583">583: </a>      c = (int)lc;
<a name="line584">584: </a>      <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G %G c\n"</font>,rgb[0][c],rgb[1][c],rgb[2][c]);
<a name="line585">585: </a>      <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"%G %G m %G %G l\n"</font>,lx,y,lx+1,y);
<a name="line586">586: </a>    }
<a name="line587">587: </a>  }
<a name="line588">588: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIISynchronizedPrintf.html#PetscViewerASCIISynchronizedPrintf">PetscViewerASCIISynchronizedPrintf</A>(ps-&gt;ps_file,<font color="#666666">"grestore\n"</font>);
<a name="line589">589: </a>  <font color="#4169E1">return</font>(0);
<a name="line590">590: </a>}







</pre>
</body>

</html>
